﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Builder
{
    public partial class MainWindow : Form
    {
        public MainWindow()
        {
            InitializeComponent();

            treeView.AllowDrop = true;

            // Component c = new Component();
            // componentPage.Controls.Add(c);

            addComponent (typeof(Record));
            addComponent (typeof(Field));
        }

        private void addComponent(Type type)
        {
            Component c = new Component (type);

            int n = componentPage.Controls.Count;
            c.Left = c.Left + n * (c.Width + c.Left);
            componentPage.Controls.Add(c);

        }

        private void quitMenuItem_Click(object sender, EventArgs e)
        {
            Close();
        }

        private void treeView_DragEnter(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent ("Builder.Component"))
               e.Effect = DragDropEffects.Copy;
        }

        private void treeView_DragDrop(object sender, DragEventArgs e)
        {
            if (e.Data.GetDataPresent("Builder.Component"))
            {
                Component c = e.Data.GetData("Builder.Component") as Component;
                Type t = c.getType();
                Object obj = Activator.CreateInstance(t);

                TreeNode node = new TreeNode();
                node.Text = obj.ToString();
                node.Tag = obj;
                node.BackColor = c.BackColor;

                Point pt = treeView.PointToClient(new Point(e.X, e.Y));
                TreeNode target = treeView.GetNodeAt(pt);
                if (target != null)
                    target.Nodes.Add(node);
                    // target.Nodes.Insert(0, node);
                else
                    treeView.Nodes.Add(node);
            }

        }
    }
}
